require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MALLOC_H)) {
    eval 'sub _MALLOC_H () {1;}' unless defined(&_MALLOC_H);
    require 'features.ph';
    if(defined( &__STDC__) || defined ( &__cplusplus)) {
	require 'stddef.ph';
	eval 'sub __malloc_ptr_t () { &void *;}' unless defined(&__malloc_ptr_t);
    } else {
	undef(&size_t) if defined(&size_t);
	eval 'sub size_t () {\'unsigned int\';}' unless defined(&size_t);
	undef(&ptrdiff_t) if defined(&ptrdiff_t);
	eval 'sub ptrdiff_t () {\'int\';}' unless defined(&ptrdiff_t);
	eval 'sub __malloc_ptr_t () {\'char\' *;}' unless defined(&__malloc_ptr_t);
    }
    if(defined(&_LIBC)) {
	eval 'sub __malloc_size_t () {\'size_t\';}' unless defined(&__malloc_size_t);
	eval 'sub __malloc_ptrdiff_t () { &ptrdiff_t;}' unless defined(&__malloc_ptrdiff_t);
    }
 elsif(!defined (defined(&__attribute_malloc__) ? &__attribute_malloc__ : undef)) {
	eval 'sub __attribute_malloc__ () {1;}' unless defined(&__attribute_malloc__);
    }
    if(defined(&__GNUC__)) {
	unless(defined(&__THROW)) {
	    if(defined (defined(&__cplusplus) ? &__cplusplus : undef)  && ((defined(&__GNUC__) ? &__GNUC__ : undef) >= 3|| (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) >= 8)) {
		eval 'sub __THROW () { &throw ();}' unless defined(&__THROW);
	    } else {
		eval 'sub __THROW () {1;}' unless defined(&__THROW);
	    }
	}
	eval 'sub __MALLOC_P {
	    my($args) = @_;
    	    eval q($args  &__THROW);
	}' unless defined(&__MALLOC_P);
	eval 'sub __MALLOC_PMT {
	    my($args) = @_;
    	    eval q($args);
	}' unless defined(&__MALLOC_PMT);
    } else {
	eval 'sub __THROW () {1;}' unless defined(&__THROW);
	if((defined (defined(&__STDC__) ? &__STDC__ : undef)  && (defined(&__STDC__) ? &__STDC__ : undef)) || defined (defined(&__cplusplus) ? &__cplusplus : undef)) {
	    eval 'sub __MALLOC_P {
	        my($args) = @_;
    		eval q($args);
	    }' unless defined(&__MALLOC_P);
	    eval 'sub __MALLOC_PMT {
	        my($args) = @_;
    		eval q($args);
	    }' unless defined(&__MALLOC_PMT);
	    unless(defined(&__const)) {
		eval 'sub __const () { &const;}' unless defined(&__const);
	    }
	} else {
	    eval 'sub __MALLOC_P {
	        my($args) = @_;
    		eval q(());
	    }' unless defined(&__MALLOC_P);
	    eval 'sub __MALLOC_PMT {
	        my($args) = @_;
    		eval q(());
	    }' unless defined(&__MALLOC_PMT);
	    unless(defined(&__const)) {
		eval 'sub __const () {1;}' unless defined(&__const);
	    }
	}
    }
    unless(defined(&NULL)) {
	if(defined(&__cplusplus)) {
	    eval 'sub NULL () {0;}' unless defined(&NULL);
	} else {
	    eval 'sub NULL () {(( &__malloc_ptr_t) 0);}' unless defined(&NULL);
	}
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&M_MXFAST)) {
	eval 'sub M_MXFAST () {1;}' unless defined(&M_MXFAST);
    }
    unless(defined(&M_NLBLKS)) {
	eval 'sub M_NLBLKS () {2;}' unless defined(&M_NLBLKS);
    }
    unless(defined(&M_GRAIN)) {
	eval 'sub M_GRAIN () {3;}' unless defined(&M_GRAIN);
    }
    unless(defined(&M_KEEP)) {
	eval 'sub M_KEEP () {4;}' unless defined(&M_KEEP);
    }
    eval 'sub M_TRIM_THRESHOLD () {-1;}' unless defined(&M_TRIM_THRESHOLD);
    eval 'sub M_TOP_PAD () {-2;}' unless defined(&M_TOP_PAD);
    eval 'sub M_MMAP_THRESHOLD () {-3;}' unless defined(&M_MMAP_THRESHOLD);
    eval 'sub M_MMAP_MAX () {-4;}' unless defined(&M_MMAP_MAX);
    eval 'sub M_CHECK_ACTION () {-5;}' unless defined(&M_CHECK_ACTION);
    if(defined(&__cplusplus)) {
    }
}
1;
